;+
;
; @file_comments
;
; @categories
; Compound widget
;
; @param EVENT
;
; @returns
;
; @uses
;
; @restrictions
;
; @examples
;
; @history
;
; @version
; $Id$
;
;-
FUNCTION cw_pagelayout_event, event
;
  compile_opt idl2, strictarrsubs
;

   widget_control, event.id, get_uvalue=uval
   widget_control, event.top, get_uvalue=top_uvalue
;
   smallin = extractatt(top_uvalue, 'smallin')
   numdessinin = smallin[2]-1
   smallout = extractatt(top_uvalue, 'smallout')
;
   if uval.name EQ 'undo' then begin
      return,{ID:event.handler, TOP:event.top, HANDLER:0L}
   ENDIF ELSE BEGIN
;
@common
; If we do not change the number of columns, we send
      if uval.name EQ 'column' then $
       if event.index+1 EQ smallin[0] THEN $
       return,{ID:event.handler, TOP:event.top, HANDLER:0L}
; If we do not change the number of lines, we send
      if uval.name EQ 'row' then $
       if event.index+1 EQ smallin[1] THEN $
       return,{ID:event.handler, TOP:event.top, HANDLER:0L}
;
; We erase the page
;      graphid = widget_info(event.top,find_by_uname = 'graph')
      graphid = extractatt(top_uvalue, 'graphid')
      widget_control,graphid,get_value=win
      wset, win
      erase, 255
      case uval.name of
         'clear':
         'column':BEGIN
            smallin = [event.index+1, smallin[1], 1]
            smallout = [event.index+1, smallout[1], 1]
         END
         'row':BEGIN
            smallin = [smallin[0], event.index+1, 1]
            smallout = [smallout[0], event.index+1, 1]
         END
      endcase
      nbredessin = smallin[0]*smallin[1]
;
; We put all back to 0 for postscripts
      createhistory, event.top, smallin
;
      options = extractatt(top_uvalue, 'options')
      flags = extractatt(top_uvalue, 'optionsflag')
      flag = flags[*, numdessinin]
;
; update and reset all values of the top_uvalue...
;
      *top_uvalue[1, findline(top_uvalue, 'smallin')] = smallin
      *top_uvalue[1, findline(top_uvalue, 'smallout')] = smallout
;
      *top_uvalue[1, findline(top_uvalue, 'penvs')] = replicate(!p, nbredessin)
      *top_uvalue[1, findline(top_uvalue, 'xenvs')] = replicate(!x, nbredessin)
      *top_uvalue[1, findline(top_uvalue, 'yenvs')] = replicate(!y, nbredessin)
;
      *top_uvalue[1, findline(top_uvalue, 'nameprocedures')] = strarr(nbredessin)
      *top_uvalue[1, findline(top_uvalue, 'types')] = strarr(nbredessin)
      *top_uvalue[1, findline(top_uvalue, 'varinfo')] = strarr(2, nbredessin)
      *top_uvalue[1, findline(top_uvalue, 'domaines')] = fltarr(6, nbredessin)
      *top_uvalue[1, findline(top_uvalue, 'dates')] = lonarr(2, nbredessin)
      *top_uvalue[1, findline(top_uvalue, 'txtcmd')] = strarr(nbredessin)
      *top_uvalue[1, findline(top_uvalue, 'optionsflag')] = flag#replicate(1, nbredessin)
;
      ptr_free, extractatt(top_uvalue, 'exextra')
      *top_uvalue[1, findline(top_uvalue, 'exextra')] = ptrarr(nbredessin, /allocate_heap)
;      *top_uvalue[1, findline(top_uvalue, '')] =
;
   ENDELSE

   return,{ID:event.handler, TOP:event.top, HANDLER:0L}
end
;
;+
;
; @file_comments
;
; @categories
; Compound widget
;
; @param PARENT {in}{required}
; The widget ID of the parent widget.
;
; @param SMALL
;
; @keyword COLUMN
; Buttons will be arranged in the number of columns
; specified by this keyword.
;
; @keyword ROW
; Buttons will be arranged in the number of rows
; specified by this keyword.
;
; @keyword UVALUE
; The user value to be associated with the widget.
;
; @keyword UNAME
; The user name to be associated with the widget.
;
; @keyword _EXTRA
; Used to pass keywords
;
; @keyword UNZOOM
;
; @returns
;
; @uses
;
; @restrictions
;
; @examples
;
; @history
;
; @version
; $Id$
;
; @todo
; seb: documenter
;
;-
FUNCTION cw_pagelayout, parent, small, UVALUE=uvalue, UNAME=uname $
                      , UNZOOM=unzoom, COLUMN=column, ROW=row, _EXTRA=ex
;
  compile_opt idl2, strictarrsubs
;
  row = keyword_set(row)*(1-keyword_set(column))
  if NOT keyword_set(uvalue) then uvalue = ''
  if NOT keyword_set(uname) then uname = ''
  base = widget_base(parent $
                     , EVENT_FUNC = 'cw_pagelayout_event' $
                     , FUNC_GET_VALUE = 'cw_pagelayout_get_value' $
                     , PRO_SET_VALUE = 'cw_pagelayout_set_value' $
                     , UVALUE = uvalue, UNAME = uname, space = 0, _extra = ex)
;------------------------------------------------
  IF n_elements(small) eq 0 then small = [1, 1, 1]
;
  dummy = widget_label(base, value = 'cln', yoffset = 3)
  id = widget_combobox(base, value = strtrim(indgen(9)+1, 1), uvalue = {name:'column'} $
                       , uname = 'column', xoffset = 20, xsize = 40)
  widget_control, id, set_combobox_select = small[0]-1
;
  IF keyword_set(row) THEN BEGIN
    xoff = 60
    yoff = 0
  ENDIF ELSE BEGIN
    xoff = 0
    yoff = 20
  ENDELSE
  dummy = widget_label(base, value = 'row', xoffset = xoff, yoffset = yoff+3)
  id = widget_combobox(base, value = strtrim(indgen(9)+1, 1), uvalue = {name:'row'} $
                       , uname = 'row', xoffset = xoff+20, xsize = 40, yoffset = yoff)
  widget_control, id, set_combobox_select = small[1]-1
;------------------------------------------------
;------------------------------------------------
  return, base
end
